<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*"%>
<%@ page import="com.esko.webcenter.src.xml.*"%>
<%@ page import="com.esko.webcenter.src.root.*" %>
<%@ page import="com.esko.webcenter.cache.*" %>
<%@ page import="java.sql.Timestamp" %>
<%@ page import="java.util.concurrent.TimeUnit" %>
<%@ page import="com.esko.util.*" %>

<%
	// === Start of the main scriplet ===

	String loginID = LoginMgr.getLoginMgr(session).getLoginID() ;

	// create the beans 
	CategoryTM categoryTM = DBTMUtils.findBean(response, session, CategoryTM.class);
	ProjectWcTaskMgrTM taskMgrTM = DBTMUtils.findBean(response, session, ProjectWcTaskMgrTM.class);
	if (categoryTM == null || taskMgrTM== null) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);		
		return;
	}
	
	// get parameters 	
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);
	
	
	
	// when the call is an ajax call, the info needs to be limited
	boolean isAjaxCall = false;	
	if (requestParams.containsKey("ajax")){
		String ajaxParamValue = ((String[])requestParams.get("ajax"))[0]; 
		if ( ajaxParamValue!=null && ajaxParamValue.equals("1")   )
			isAjaxCall = true;
	}
	boolean limitInformation =isAjaxCall ; // use proper name to reflect the true meaning of the variable  
		
	Category category = null;

	// get Category ID and/or wctask ID
	String categoryID = (requestParams.containsKey("categoryid")) ? ((String[])requestParams.get("categoryid"))[0] : null;
	String taskID = (requestParams.containsKey("taskid")) ? ((String[])requestParams.get("taskid"))[0] : null;
	String taskTypeID = (requestParams.containsKey("tasktypeid")) ? ((String[])requestParams.get("tasktypeid"))[0] : null;
	String viewName = (requestParams.containsKey("view")) ? ((String[])requestParams.get("view"))[0] : null;
	String fallback = (requestParams.containsKey("fallback")) ? ((String[])requestParams.get("fallback"))[0] : null;

	// Support for caching
	// Is the timestamp object available? If so, raise the cache flags 
	if (requestParams.containsKey("lastmodified") && IdGenerator.isIDFormat(categoryID)){	
		try {
			// only cache if the format of lastmodified is correct
			Long.parseLong(((String[])requestParams.get("lastmodified"))[0]);
			
			// We DO want the GetAttributeCategory calls to be cached. 
			// to prevent caching a cachebuster parameter should be added to the GetAttributeCategory call.
			// set cache headers for 1 month
			Timestamp lastModified = categoryTM.getModifiedTimeStamp(loginID,categoryID);
			
			final long ONE_MONTH =  TimeUnit.DAYS.toSeconds(30);
			response.setHeader("Cache-Control", "public");
			response.addHeader("Cache-Control", "max-age=" + ONE_MONTH);
			response.addHeader("Cache-Control", "s-maxage=" + ONE_MONTH);
			response.setDateHeader("Last-Modified", lastModified.getTime() );
			
			// HTTP 1.0
			response.setHeader("Pragma", "public");
			// time in two months
			long expires = (ONE_MONTH*1000) + System.currentTimeMillis();
			if (ONE_MONTH < 0) // not in this lifetime, but for completeness
				expires = Long.MAX_VALUE;
			response.setDateHeader("Expires", expires);	
		} catch(NumberFormatException nex){
			// do nothing: lastmodifiedparameter was passed, but was not a date, don't use caching
		}
	}
	
	try {
		if (IdGenerator.isIDFormat(categoryID)) {
			// categoryID parameter is preferred
			// load the specified attribute category from database
			category = CategoryObjectCache.get(loginID,categoryID, viewName, fallback, categoryTM);
		}
		else if (IdGenerator.isIDFormat(taskID)) {
			// wctask specifications have no category of attributes assigned (for now)
			// the code here is to overcome this limitation until the attributes and specifications are merged
			category = new Category();
			category.setName("Task Specifications");
			category.setObjectID("");   // just a fake category not existing in database
			
			
			// load all task attributes (specifications) and store them within just created category
			// (the first null parameter stands for project ID that must not be specified)
			Vector attrValueList = taskMgrTM.loadAttributesViewByTask(loginID, null, taskID, null);
			if ((attrValueList != null) && (attrValueList.size() > 0)) {
				// convert AttributeValueViews list to Attributes list...
				Vector attrList = new Vector(attrValueList.size());
				for (int i = 0; i < attrValueList.size(); i++) {
					AttributeValueView attrView = (AttributeValueView)attrValueList.get(i);
					attrList.add(attrView.getAttribute());
				}
				// ...and store it in the created category instance
				category.loadAttributeList(attrList);
			}
		}
		else if (IdGenerator.isIDFormat(taskTypeID)) {
			// wctask type specifications have no category of attributes assigned (for now)
			// the code here is to overcome this limitation until the attributes and specifications are merged
			category = new Category();
			category.setName("Task Type Specifications");
			category.setObjectID("");   // just a fake category not existing in database
			
			
			// load the selected task type
			//WcTaskType taskType = taskMgrTM.findTaskTypeById(loginID, taskTypeID); 
			//if (taskType != null) {
				byte[] layoutXML = taskMgrTM.loadWcTaskTypeLayoutXML(loginID, taskTypeID);
				category.setCategoryXML(layoutXML);
				// load all task attributes (specifications) for the selected task type and store them 
				// within the just created category
				Vector<WcTaskTypeSpecificationView> specViewList = taskMgrTM.loadWcTaskTypeSpecifications(loginID, taskTypeID, null);
				if ((specViewList != null) && (specViewList.size() > 0)) {
					// convert WcTaskTypeSpecificationView list to Attributes list...
					Vector specList = new Vector(specViewList.size());
					for (WcTaskTypeSpecificationView specView : specViewList) {
						specList.add(specView.getSpecification());
					}
					// ...and store it in the created category instance
					category.loadAttributeList(specList);
				}	
			//}
		}
		else {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
	}
	catch (Exception ex) {
		category = null;
	}	

	if (category == null) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_ATTR));
		checkLogOff(session);
		return;
	} 
	
	// Document reference attributes can contain a category as reference category
	// we need to know the name of this category. That's why we load it from the cache and
	// pass it to the call that outputs the attributes to XML 
	Hashtable<String, Category> categories = CategoryListCache.getCategoriesHashtable(response, session);
	
	// generate and write out the XML output	
	out.write("<attribute_category>");
	CategoryXml categoryXML = new CategoryXml();
	
	
	// translate the attributes used in the categories, do this right before exporting this
	Vector<Attribute> attributeList = category.getAttributeList();
	String langKey = LoginMgr.getLoginMgr(session).getLangKey(session);
	
	for (Attribute attribute: attributeList ){
		String languageTag = attribute.getLanguageTag();
		if (StringUtils.checkForValue(languageTag)) {
			String translatedString  = LanguageMgr.resolveCustomizableLabel(langKey, languageTag);
			if (translatedString!= null){ 
				attribute.setTranslatedTag(translatedString);
			}
		}
	}	
	
	categoryXML.dumpFieldsInXml(category, out, limitInformation, categories);
	out.write("</attribute_category>");
	
	checkLogOff(session);
%>
