<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr" exclude-result-prefixes="Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>
  <xsl:import href="templatedate.xsl"/>
  <xsl:import href="docdetails_template.xsl"/>

  
  
 
  <!-- override templates to prevent them showing anything -->

  <xsl:template name="welcomeEtc" />

  <xsl:template name="headerUserActions"/>
  <xsl:template name="headerMenuBar"/>
  <xsl:template name="headerMenuScripts"/>
  
  <xsl:template name="isWizardPage">
    <xsl:value-of select="true()"/>
  </xsl:template>
  
  <xsl:template name="isNameLink">
    <xsl:value-of select="false()"/>
  </xsl:template>
    
  <xsl:template name="bodyextensions">
  	<xsl:attribute name="scroll">yes</xsl:attribute>
  </xsl:template>
   
  <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">  
	
	<xsl:variable name="isPrinting">
		<xsl:call-template name="isPrinting"/>
	</xsl:variable>

    <tr class="white_background"><td height="5"/></tr>
    <xsl:if test="count(showimage)>0">
	    <tr>
		    <td width="100%" align="center" class="darktext_darklink_11">
				<xsl:variable name="selectedVersionID" select="doc_version/@id"/>    
				<xsl:variable name="maxPixSizeX">
					<xsl:choose>
						<xsl:when test="count(maxpixsizex)>0">
							<xsl:value-of select="maxpixsizex"/>
						</xsl:when>
						<xsl:when test="count(maxpixsize)>0">
							<xsl:value-of select="maxpixsize"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1000"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="maxPixSizeY">
					<xsl:choose>
						<xsl:when test="count(maxpixsizey)>0">
							<xsl:value-of select="maxpixsizey"/>
						</xsl:when>
						<xsl:when test="count(maxpixsize)>0">
							<xsl:value-of select="maxpixsize"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1000"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="pageIndex" select="0"/>
		   		<xsl:variable name="srcUrl" select="concat('DownloadViewerThumbnail.jsp?docversionid=',$selectedVersionID,'&amp;mpx=',$maxPixSizeX,'&amp;mpy=',$maxPixSizeY,'&amp;pageno=',$pageIndex,'&amp;ajax=1')"/>
		   		<img src="{$srcUrl}" alt="Could not generate document view" title="{doc_version/document/name}"/>
		    </td>
	    </tr>
	    <tr class="white_background"><td height="5"/></tr>
    </xsl:if> 
    <xsl:choose>
    	<!-- No Category assigned : display the appropriate message -->
    	<xsl:when test="no_attr_category_msg">
    		<tr><td class="error"><xsl:value-of select="Lang:getStr(&lk;,'DOCHASNOATTRSCATEGORY_TAG')"/></td></tr>
    	</xsl:when>
    	<xsl:otherwise>
	   		 <tr>
	      		<td width="100%" >
					<form name="actionform" method="post" action="dodocdetailsactions.jsp">	
						<input type="hidden" name="actionVal" value="SaveAttributes"/>
						<xsl:call-template name="docDetailsHiddenInputs"/>
						<div id="ACatObj"></div>
						<div id="ACatPanel"></div>
					</form>
	      		</td>
	    	</tr>
    	</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
	<xsl:template name="pagesubtitle">
		<!-- display secondary header -->
	 	 <xsl:variable name="catDisplayName">
	        <xsl:choose>
	          <xsl:when test="/webcenter_page/category/name"><xsl:value-of select="/webcenter_page/category/name"/></xsl:when>
	          <xsl:otherwise>---</xsl:otherwise>
	        </xsl:choose>
	    </xsl:variable>
	   <xsl:variable name="catDisplayViewName">
	       <xsl:choose>
	         <xsl:when test="/webcenter_page/attrcatview"><xsl:value-of select="/webcenter_page/attrcatview"/></xsl:when>
	         <xsl:otherwise><xsl:value-of select="Lang:getStr(&lk;, 'ACLayoutDefault')"/></xsl:otherwise>
	       </xsl:choose>
	   </xsl:variable>
	
		<xsl:call-template name="DetailsAttributeHeader">
			<xsl:with-param name="catDisplayName" select="$catDisplayName"/>
			<xsl:with-param name="catDisplayViewName" select="$catDisplayViewName"/>
			<xsl:with-param name="isEditable" select="false()"/>
			<xsl:with-param name="changeActionValue" select="''" />
			<xsl:with-param name="showPrintButton" select="true()" />
			<!-- when we are in a custom view, override the header with the label of the menu -->
			<xsl:with-param name="useLabelOfDetailsMenu" select="boolean(/webcenter_page/attrcatview)"/>
		</xsl:call-template>	
	</xsl:template>
   
    
 <!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
    <script src="javascript/TableSelection.js"/>&#xA;
    <script src="javascript/validate.js"/>&#xA;
    <script src="javascript/detailswin.js"/>&#xA;
	
    <script type="text/javascript">
      		
        function PrintWindow()
        {
			window.print();
        }
            
    </script>
    <style>
      #ui-datepicker-div
      {
      z-index: 9999999;
      }
    </style>
    <script type="text/javascript">
      <xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
		<xsl:if test="/webcenter_page/category/@id">
		var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + '<xsl:value-of select="/webcenter_page/category/@id"/>';
		// ensure to only append the category's mod date when it is known
		<xsl:if test="/webcenter_page/category/mod_time_stamp">
			readURL  += '&amp;lastmodified='+ <xsl:value-of select="/webcenter_page/category/mod_time_stamp"/> ;
		</xsl:if>
		
		var valuesURL = "GetAttributes.jsp?docverid="+'<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function(AttributeCategory, ObjectHandler){
			$(function() {
				var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
				currentUser.canEditAttributes = false;
				var aCatOptions = new Object();
				aCatOptions.ACatObj = "ACatObj";
				aCatOptions.ACatPanel = "ACatPanel";
				aCatOptions.readURL = readURL;
				aCatOptions.currentUser = currentUser;
				aCatOptions.valuesURL = valuesURL;
				aCatOptions.defaultHourAsHalfHours = <xsl:value-of select="/webcenter_page/default_due_date_time"/>;
				<xsl:if test="count(/webcenter_page/attrcatview)>0">
					aCatOptions.view='<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
					aCatOptions.readURL += '&amp;view=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>'
				</xsl:if>
				aCatOptions.printLayout = true;
				aCatOptions.type = "document";
				aCatOptions.projectID = '<xsl:value-of select="/webcenter_page/doc_version/project_id"/>';
				aCatOptions.documentID = '<xsl:value-of select="/webcenter_page/doc_version/document/@id"/>';
				aCatOptions.docVersionID = '<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
				if (aCatOptions.docVersionID) {
					// to be used to detect cyclic dependencies in document references
					aCatOptions.docTableParentDocVerIDs = [aCatOptions.docVersionID];
				}
				myACat = new AttributeCategory(aCatOptions);
			});
		});
		</xsl:if>
      <xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
    </script>

    <xsl:call-template name="DocDetailsJavaScript"/> 
	<xsl:call-template name="AttributeTemplateJavaScript"/>	
  </xsl:template>
</xsl:stylesheet>
