<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:java="http://xml.apache.org/xslt/java" xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr"
	exclude-result-prefixes="XSLUtils java Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="templatedetailsreadonly.xsl"/>
  <xsl:import href="attrunittmplts.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>

  
  
  
  <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">
	<xsl:variable name="categoryID" select="project/category_id"/>

	<xsl:choose>
		<xsl:when test="string-length($categoryID) = 0">
			<xsl:call-template name="NoCategory"/>
		</xsl:when>
		<xsl:otherwise><xsl:call-template name="DisplayCategory"/></xsl:otherwise>
	</xsl:choose>

  </xsl:template>
  
  
  <xsl:template name="NoCategory">
	<tr class="white_background"><td class="darktext_darklink_bold_12" align="center">
		<xsl:value-of select="Lang:getStr(&lk;,'NOATTCATEGORY')"/>		
	</td></tr>	
  </xsl:template>
  
  
  
  <xsl:template name="DisplayCategory">

    <xsl:variable name="catDisplayName">
        <xsl:choose>
          <xsl:when test="category/name"><xsl:value-of select="category/name"/></xsl:when>
          <xsl:otherwise>---</xsl:otherwise>
        </xsl:choose>
    </xsl:variable>

    <tr class="detailsHeader">
		<td align="left" class="darktext_darklink_bold_12">	
			<img border="0" src="images/clearpixel.gif" width="10" height="1"/><xsl:value-of select="Lang:getStr(&lk;,'ATTSEARCHTITLE')"/>
			&nbsp;
			<em><xsl:value-of select="$catDisplayName"/></em>
		</td>
    </tr>
	
    <tr class="white_background"><td><img src="images/clearpixel.gif" width="1" height="10" /></td></tr>
    

    <tr>
      <td width="100%" >
	   <form name="actionform" method="post" action="doprojectdetailsactions.jsp">
	       <xsl:call-template name="projDetailsHiddenInputs"/>
	   <input type="hidden" name="actionVal" value="SaveProjectAttributes"/>
        <div id="ACatObj"></div>
        <div id="ACatPanel"></div>
		</form>
      </td>
    </tr>
  </xsl:template>
  
 
  <!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
    <script src="javascript/validate.js" type="text/javascript"/>
    <script src="javascript/TableSelection.js" type="text/javascript"/>

    <script src="javascript/webcenter_ajax.js" type="text/javascript"/>
    <script src="javascript/webcenter_xml.js" type="text/javascript"/>
    <script src="javascript/webcenter_html.js" type="text/javascript"/>
    <style>
      #ui-datepicker-div
      {
      z-index: 9999999;
      }
    </style>
    
    <script type="text/javascript">
			<xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
//Contents for menu 1
<xsl:variable name="catHref">projdetailsattrscategory.jsp?<xsl:call-template name="menuFileUrlParameter"/></xsl:variable>

var catMenu=new Array();
catMenu[0]='&lt;a href="<xsl:value-of select="$catHref"/>"&gt;Change Category&lt;\/a&gt;&lt;br&gt;';

		<xsl:if test="/webcenter_page/category/@id">
		
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function(AttributeCategory, ObjectHandler){
	      $(function() {
	      
		      var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
		      currentUser.canEditAttributes = false;
				  var aCatOptions = new Object();
		      aCatOptions.ACatObj = "ACatObj";
				  aCatOptions.isTemplate = true;
		      aCatOptions.ACatPanel = "ACatPanel";
		      
		      aCatOptions.readURL = "GetAttributeCategoryXML.jsp?view=Default&amp;categoryid=" + '<xsl:value-of select="/webcenter_page/category/@id"/>';
		      var catModifiedDate = <xsl:value-of select="/webcenter_page/category/mod_time_stamp"/> ;
		      if (catModifiedDate){
		      	 aCatOptions.readURL += '&amp;lastmodified='+catModifiedDate ;
		      }
		      aCatOptions.currentUser = currentUser;
		      aCatOptions.valuesURL = "GetAttributes.jsp?projectid=" +'<xsl:value-of select="/webcenter_page/project/@id"/>';
		      aCatOptions.type = "project";
		      aCatOptions.projectID = '<xsl:value-of select="/webcenter_page/project/@id"/>';
		      myACat = new AttributeCategory(aCatOptions);
	      });
	     });
		</xsl:if>


      <xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
    </script>
    <xsl:call-template name="ProjDetailsJavaScript"/>  
	<xsl:call-template name="AttributeTemplateJavaScript"/>
  </xsl:template>     
</xsl:stylesheet>
